#include <KAboutData>
#include <KIconTheme>
#include <KLocalizedContext>
#include <KLocalizedQmlContext>
#include <KLocalizedString>
#include <QApplication>
#include <QIcon>
#include <QQmlApplicationEngine>
#include <QQuickStyle>
#include <QUrl>
#include <QtQml>
#include <qcoreapplication.h>

#include "../tutorial-kirigami2-version.h"

using namespace Qt::Literals::StringLiterals;

int main(int argc, char *argv[]) {
    KIconTheme::initTheme();
    QIcon::setFallbackThemeName(u"breeze"_s);
    QApplication app(argc, argv);
    // Default to org.kde.desktop style unless the user forces another style
    if (qEnvironmentVariableIsEmpty("QT_QUICK_CONTROLS_STYLE")) {
        QQuickStyle::setStyle(u"org.kde.desktop"_s);
    }

    KLocalizedString::setApplicationDomain("tutorial_kirigami2");
    QGuiApplication::setWindowIcon(QIcon::fromTheme(u"fr.mrdev023.tutorial_kirigami2"_s));

    KAboutData about(u"tutorial_kirigami2"_s,
                     i18nc("Application name", "Tutorial Kirigami 2"),
                     QStringLiteral(TUTORIAL_KIRIGAMI2_VERSION_STRING),
                     i18n("Note taking application"),
                     KAboutLicense::MIT,
                     i18n("© 2025-2025 Florian RICHER"));
    about.addAuthor(i18n("Florian RICHER"),
                    i18n("Maintainer"),
                    u"florian.richer@protonmail.com"_s,
                    u"https://invent.kde.org/florianricher"_s,
                    QUrl(u"https://gravatar.com/avatar/f9c35f242fe79337bf8746ca9fccc189?size=256.png"_s));
    
    KAboutData::setApplicationData(about);

    QQmlApplicationEngine engine;
    KLocalization::setupLocalizedContext(&engine);

    engine.loadFromModule(u"fr.mrdev023.tutorial_kirigami2"_s, u"Main"_s);

    if (engine.rootObjects().isEmpty()) {
        return -1;
    }

    return app.exec();
}
